function u = InvWaveTransform2D(WT,rh,rg,scale)
% reconstructs signal using the filters rh and rg
for i = scale:-1:1
    % loRes reconstruction filtering
    lopart = zeroinsert2D(WT.LoRes);
    lopart = myconv2D(rh,rh,lopart);
    % row detail reconstruction filtering
    hipart.r = WT.Details{i}.r;
    hipart.r = zeroinsert2D(hipart.r);
    hipart.r = myconv2D(rh,rg,hipart.r);
    % colum detail reconstruction filtering
    hipart.c = WT.Details{i}.c;
    hipart.c = zeroinsert2D(hipart.c);
    hipart.c = myconv2D(rg,rh,hipart.c);
    % diagonal detail reconstruction filtering
    hipart.d = WT.Details{i}.d;
    hipart.d = zeroinsert2D(hipart.d);
    hipart.d = myconv2D(rg,rg,hipart.d);
    % add all four
    sum1 = addSignals2D(lopart,hipart.r);
    sum2 = addSignals2D(hipart.c,hipart.d);
    WT.LoRes = addSignals2D(sum1,sum2);
end
u = WT.LoRes;