function y = zeroinsert2D(x)
% inserts zeros between every sample of a discrete signal/filter
% the signal/filter is structured, i.e. it has two fields

% The input is a structured matrix
[n,m] = size(x.s);
y.s = zeros(2*m-1,2*n-1);
y.s(1:2:end,1:2:end) = x.s;
% now we handle the delay term. This is easier to understand if we use the 
% z-transform of the input. The output z-transform is obtained from the 
% input z-transform by replacing every monomial z^k by its square z^(2*k)
% hence the minimum degree that appears in the z-transform is doubled in 
% the operation.
y.rd = 2*x.rd;
y.cd = 2*x.cd;